-- /packages/intranet-gtd-dashboard/sql/postgresql/intranet-gtd-dashboard-create.sql
--
-- Copyright (c) 2003-2009 ]project-open[
--
-- All rights reserved. Please check
-- https://www.project-open.com/license/ for details.
--
-- @author klaus.hofeditz@project-open.com



------------------------------------------------------
-- GTD table
--

create sequence im_gtd_tasks_seq start with 100;
create table im_gtd_tasks (
        gtd_task_id             integer
                                primary key,
	ref_id			integer
				not null,
        owner_id                integer
                                references users,
        created_date            timestamptz,
        description             text,
        last_modified           date,
        -- Status and type for orderly objects...
        gtd_type_id   		integer
                                constraint im_gtd_task_type_fk
                                references im_categories
                                constraint im_gtd_tasks_type_nn
                                not null,
        gtd_task_status_id      integer
                                constraint im_gtd_task_type_status_fk
                                references im_categories
                                constraint im_gtd_tasks_type_status_nn
                                not null
--	order
--	priority	
);


-- Indicices
create index im_gtd_tasks on im_gtd_tasks(gtd_task_id);


-----------------------------------------------------------
-- Type and Status
--
-- 41100-41999  Intranet GTD Dashboard

SELECT im_category_new(41400, 'GTD Project', 'Intranet Project Type');
insert into im_category_hierarchy (parent_id, child_id) values (2501, 41400);


SELECT im_category_new(41100, 'Intranet GTD Task Type', '');
SELECT im_category_new(41101, 'Intranet GTD Task Status', '');

SELECT im_category_new (41200, 'ts', 'Intranet GTD Task Type');

SELECT im_category_new (41300, 'Active' 'Intranet GTD Task Status');
SELECT im_category_new (41301, 'Deleted', 'Intranet GTD Task Status');




-----------------------------------------------------------
-- Create the object type

-- SELECT acs_object_type__create_type (
--         'im_gtd_item',                  -- object_type
--         'GTD Task',                     -- pretty_name
--         'GTD Tasks',                    -- pretty_plural
--        'acs_object',                   -- supertype
--        'im_gtd_tasks',                 -- table_name
--        'gtd_task_id',                  -- id_column
--        'intranet-gtd-dashboard',       -- package_name
--        'f',                            -- abstract_p
--        null,                           -- type_extension_table
--        'im_gtd_task__name'             -- name_method
-- );

-- insert into acs_object_type_tables (object_type,table_name,id_column)
-- values ('im_gtd_item', 'im_gtd_tasks', 'gtd_task_id');


-- Setup status and type columns for im_gtd_item
-- update acs_object_types set
--         status_type_table = 'im_gtd_tasks',
--         status_column = 'gtd_task_id',
--        type_column = 'gtd_task_type_id'
-- where object_type = 'im_gtd_item';




-- Define how to link to Absence pages from the Forum or the
-- Search Engine
-- insert into im_biz_object_urls (object_type, url_type, url) values (
-- 'im_user_absence','view','/intranet-timesheet2/absences/new?form_mode=display&absence_id=');
-- insert into im_biz_object_urls (object_type, url_type, url) values (
-- 'im_user_absence','edit','/intranet-timesheet2/absences/new?absence_id=');



-- Unique constraint to avoid that you can add two identical absences
-- alter table im_user_absences
-- add constraint owner_and_start_date_unique unique (owner_id, gtd_task_type_id, start_date);

-- Indicices
-- create index im_user_absences_dates_idx on im_user_absences(start_date, end_date);
-- create index im_user_absences_type_idx on im_user_absences(gtd_task_type_id);


-----------------------------------------------------------
-- Create, Drop and Name PlPg/SQL functions
--
-- These functions represent creator/destructor
-- functions for the OpenACS object system.

-- create or replace function im_gtd_task__name(integer)
-- returns varchar as '
-- DECLARE
--         p_gtd_task_id            alias for $1;
--         v_name                  varchar;
-- BEGIN
--         select  gtd_task_name into v_name
--         from    im_gtd_tasks
--         where   gtd_task_id = p_gtd_task_id;

        -- compatibility fallback
--        IF v_name is null THEN
--                select  substring(description for 1900) into v_name
--                from    im_user_absences
--                where   gtd_task_id = p_gtd_task_id;
--        END IF;

--        return v_name;
-- end;' language 'plpgsql';


-- create or replace function im_gtd_task__new (
--        integer, varchar, timestamptz,
--        integer, varchar, integer,
--        varchar, integer, timestamptz, timestamptz,
--        integer, integer, varchar, varchar
-- ) returns integer as '
-- DECLARE
--        p_gtd_task_id            alias for $1;           -- gtd_task_id  default null
--        p_object_type           alias for $2;           -- object_type default ''im_gtd_task''
--        p_creation_date         alias for $3;           -- creation_date default now()
--        p_creation_user         alias for $4;           -- creation_user default null
--        p_creation_ip           alias for $5;           -- creation_ip default null
--        p_context_id            alias for $6;           -- context_id default null

--        p_gtd_task_name          alias for $7;           -- gtd_task_name
--        p_owner_id              alias for $8;           -- owner_id
--        p_start_date            alias for $9;
--        p_end_date              alias for $10;

--        p_gtd_task_status_id     alias for $11;
--        p_gtd_task_type_id       alias for $12;
--        p_description           alias for $13;
--        p_contact_info          alias for $14;

--        v_gtd_task_id    integer;
-- BEGIN
--        v_gtd_task_id := acs_object__new (
--                p_gtd_task_id,           -- object_id
--                p_object_type,          -- object_type
--                p_creation_date,        -- creation_date
--                p_creation_user,        -- creation_user
--                p_creation_ip,          -- creation_ip
--                p_context_id,           -- context_id
--                ''f''                   -- security_inherit_p
--        );

--        insert into im_gtd_tasks (
--                gtd_task_id, gtd_task_name,
--                owner_id, start_date, end_date,
--                gtd_task_status_id, gtd_task_type_id,
--                description, contact_info
--        ) values (
--                v_gtd_task_id, p_gtd_task_name,
--                p_owner_id, p_start_date, p_end_date,
--                p_gtd_task_status_id, p_gtd_task_type_id,
--                p_description, p_contact_info
--        );
--
--        return v_gtd_task_id;
-- END;' language 'plpgsql';


-- create or replace function im_gtd_task__delete(integer)
-- returns integer as '
-- DECLARE
--         p_gtd_task_id    alias for $1;
-- BEGIN
--         -- Delete any data related to the object
--         delete from im_gtd_tasks
--         where   gtd_task_id = p_gtd_task_id;

        -- Finally delete the object iself
--         PERFORM acs_object__delete(p_gtd_task_id);

--         return 0;
-- end;' language 'plpgsql';

------------------------------------------------------
-- Absences Permissions
--

-- add_gtd_tasks makes it possible to restrict the absence registering to internal stuff
-- SELECT acs_privilege__create_privilege('add_gtd_tasks','Add GTD Tasks','Add GTD Tasks');
-- SELECT acs_privilege__add_child('admin', 'add_gtd_tasks');

-- view_gtd_tasks_all restricts possibility to see gtd_tasks of others
-- SELECT acs_privilege__create_privilege('view_gtd_tasks_all','View GTD Tasks All','View GTD Tasks All');
-- SELECT acs_privilege__add_child('admin', 'view_gtd_tasks_all');

-- Set default permissions per group
-- SELECT im_priv_create('add_gtd_tasks', 'Employees');
-- SELECT im_priv_create('add_gtd_tasks', 'Freelancers');

-- SELECT im_priv_create('view_gtd_tasks_all', 'Accounting');
-- SELECT im_priv_create('view_gtd_tasks_all', 'Employees');
-- SELECT im_priv_create('view_gtd_tasks_all', 'Freelancers');
-- SELECT im_priv_create('view_gtd_tasks_all', 'P/O Admins');
-- SELECT im_priv_create('view_gtd_tasks_all', 'Project Managers');
-- SELECT im_priv_create('view_gtd_tasks_all', 'Sales');
-- SELECT im_priv_create('view_gtd_tasks_all', 'Senior Managers');

-- Privilege that determines if a user can override the Workflow
-- Can a user confirm his own vacation requests?
-- SELECT acs_privilege__create_privilege('edit_gtd_taskstatus','Edit Absence Status','Edit Absence Status');
-- SELECT acs_privilege__add_child('admin', 'edit_gtd_task_status');

-- SELECT im_priv_create('edit_gtd_task_status', 'Accounting');
-- SELECT im_priv_create('edit_gtd_task_status', 'P/O Admins');
-- SELECT im_priv_create('edit_gtd_task_status', 'Project Managers');
-- SELECT im_priv_create('edit_gtd_task_status', 'Senior Managers');















































